# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# define DIM_STR 51    // max 50 caratteri + byte di fine stringa (=0)

struct parola
 {
  char stringa[DIM_STR];
  struct parola *p_prossimo;
 };

struct parola *p_radice;

void leggi_stringa(char *stringa,int lunghezza);
void azzera_stringa(char *stringa,int lunghezza);
char scelta();
void crea_lista();
int metti(char *p_stringa);
void mostra();
int conta();
int trova(char *p_stringa);
unsigned int cancella(char *p_stringa);
void svuota();

main()
 {
  char str[DIM_STR];
  unsigned int num,n_cancellati;
  char opz,continua;
  p_radice=NULL;
  crea_lista();
continua=1;
  do
    {
     opz=scelta();    // opzione non ammessa
     if ((opz<1)||(opz>6))
        {
         printf("\n%s","Opzione non ammessa");
        }
     if (opz==1)   // inserimento stringa nella lista
        {
         printf("\n%s","Stringa da inserire nella lista ordinata:  ");
         leggi_stringa(str,DIM_STR);
         metti(str);
         mostra();
        }
     if (opz==2)   // cancellazione di una stringa dalla lista
        {
         printf("\n%s","Stringa da cancellare dalla lista:  ");
         leggi_stringa(str,DIM_STR);
         n_cancellati=cancella(str);
         printf("\n%s%s%s%d\n","Numero di cancellazioni di ",str,":  ",n_cancellati);
          //  }
         mostra();
        }
     if (opz==3)   // cancellazione di tutti gli elementi della lista
        {
         svuota();
         crea_lista();
         mostra();
        }
     if (opz==4)   // conteggio di tutti gli elementi della lista
        {
         num=conta();
         if (num==1)
            {
             printf("\n%s%d%s\n","La lista e' formata da ",num," elemento");
            }
         else
            {
             printf("\n%s%d%s\n","La lista e' formata da ",num," elementi");
            }
         mostra();
  }
     if (opz==5)   // conteggio delle occorrenze di una data stringa
        {
         printf("\n%s","Stringa da cercare nella lista:  ");
         leggi_stringa(str,DIM_STR);
         printf("\n%s%s%s%d\n","Occorrenze di ",str," nella lista: ",trova(str));
         mostra();
        }
     if (opz==6) continua=0;
    } while (continua==1);

    // dealloca tutti gli elementi della lista
  svuota();
  printf("\n\n");

  return 0;
 }



void leggi_stringa(char *stringa,int lunghezza)
 {
  char carattere;
  int indice;
    // assegna 0 a tutti gli elementi della stringa
  for (indice=0;indice<lunghezza;indice++)  {stringa[indice]=0;}
    // legge i singoli caratteri con getchar()
    // il ciclo si interrompe quando si digita invio 
    // (che inserisce il terminatore di stringa) 
    // o quando si e' raggiunto il numero massimo 
    // di caratteri inseribili
  indice=0;
  while (((carattere=getchar())!='\n')&&(indice<lunghezza-1))
   {
    stringa[indice++]=carattere;
   }
 }    // fine leggi_stringa()


    // assegna il valore 0 a tutti gli elementi di una stringa
void azzera_stringa(char *stringa,int lunghezza)
 {
  int indice;
  for (indice=0;indice<lunghezza;indice++)
  {stringa[indice]=0;}
 }    // fine azzera_stringa()


 // mostra un menu per la scelta dell'operazione 
    // da effettuare sulla lista ordinata di stringhe
char scelta()
 {
  char opzione;
  char opzione_str[2];
  printf("\n%s\n","---------------------------------------------");
  printf("%s\n","OPERAZIONI SULLA LISTA DI STRINGHE");
  printf("%s\n","Inserisci una stringa................................1");
  printf("%s\n","Cancella tutte le occorrenze di una data stringa.....2");
  printf("%s\n","Cancella tutte le stringhe...........................3");
  printf("%s\n","Conta tutte le stringhe..............................4");
  printf("%s\n","Conta le occorrenze di una data stringa..............5");
  printf("%s\n","Uscita dal programma.................................6");
  printf("\n%s","Scegliere operazione:  ");
  leggi_stringa(opzione_str,2);
  opzione=atoi(opzione_str);
  return opzione;
 }  // fine scelta()
    // crea la lista formata (all'inizio) solo dalle due sentinelle
void crea_lista()
 {
  struct parola *p_temp;
  // alloca spazio per la sentinella inizio, 
  // che deve essere puntata da p_radice
  p_radice=calloc(1,sizeof(struct parola));
  strcpy((*p_radice).stringa,"INIZIO");
  // alloca spazio per la sentinella fine, 
  // che deve essere puntata dalla sentinella inizio 
  // e deve puntare a NULL
  p_temp=calloc(1,sizeof(struct parola));
  strcpy((*p_temp).stringa,"FINE");  
  (*p_temp).p_prossimo=NULL;
  (*p_radice).p_prossimo=p_temp;
 }  // fine crea_lista()


  // inserisce una stringa nella lista in base all'ordine alfabetico
int metti(char *p_stringa)
 {
  struct parola *p_corrente,*p_precedente,*p_temp;
  char continua,cfr;

  p_temp=calloc(1,sizeof(struct parola));
  azzera_stringa((*p_temp).stringa,DIM_STR);
  strcpy((*p_temp).stringa,p_stringa);

  p_precedente=p_radice;
  p_corrente=(*p_radice).p_prossimo;

  continua=1;
  while (continua==1)
        {
         if ((*p_corrente).p_prossimo==NULL)
            {
             (*p_temp).p_prossimo=(*p_precedente).p_prossimo;
             (*p_precedente).p_prossimo=p_temp;
             break;
            }
           
         cfr=strcmp(p_stringa,(*p_corrente).stringa);
         if (cfr<1)
            {
             (*p_temp).p_prossimo=(*p_precedente).p_prossimo;
             (*p_precedente).p_prossimo=p_temp;
             continua=0;
            }
         else
            {
             p_precedente=p_corrente;
             p_corrente=(*p_corrente).p_prossimo;
            }   

        }  // fine ciclo while
 }  // fine metti()



void mostra()
 {
  struct parola *p_corrente;
  printf("\n%s","Lista:  ");
  p_corrente=p_radice;
  while(p_corrente!=NULL)
    {
     printf("%s%s",(*p_corrente).stringa,"   ");
     p_corrente=(*p_corrente).p_prossimo;
    }
 }  // fine mostra()


    // conta tutti gli elementi che formano la lista, 
    // meno le due sentinelle
int conta()
 {
  int n_elementi=0;
  struct parola *p_corrente;
  p_corrente=p_radice;
  while(p_corrente!=NULL)
    {
     n_elementi++;
     p_corrente=(*p_corrente).p_prossimo;
    }
  return (n_elementi-2);
 }  // fine conta()


  // conta tutte le occorrenze di una parola
int trova(char *p_stringa)
 {
  int k=0;
  char cfr;
  struct parola *p_corrente;
  p_corrente=p_radice;
  while(p_corrente!=NULL)
    {
     cfr=strcmp(p_stringa,(*p_corrente).stringa);
     if (cfr==0)  {k++;}
     p_corrente=(*p_corrente).p_prossimo;
    }
  return k;
 }  // fine trova()


    // cancella tutti gli elementi che contengono una parola data
    // rende in uscita il numero di elementi cancellati
unsigned int cancella(char *p_stringa)
 {
  unsigned int k=0;
  struct parola *p_corrente,*p_precedente,*p_temp;
  char continua,cfr;

  p_precedente=p_radice;
  p_corrente=(*p_radice).p_prossimo;

    // percorre la lista fino alla prima occorrenza 
    // della parola da cancellare, oppure fino alla sentinella fine 
  continua=1;
  while ((continua==1)&&(p_corrente!=NULL))
     {
      cfr=strcmp(p_stringa,(*p_corrente).stringa);
      if (cfr==0)
         {continua=0;}
      else
 p_precedente=p_corrente;
          p_corrente=(*p_corrente).p_prossimo;
         }
     }  // fine ciclo while

    // se e' arrivato in fondo alla lista senza trovare l'elemento 
    // da cancellare, esce dalla funzione rendendo in uscita 0
  if (p_corrente==NULL) return 0;

    // cancella la prima occorrenza della parola passata in input
  p_temp=(*p_corrente).p_prossimo;
  free((*p_precedente).p_prossimo);
  (*p_precedente).p_prossimo=p_temp;
  p_corrente=p_temp;
  k++;

    // cancella eventuali ulteriori occorrenze
  continua=1;
  while (continua==1)
     {
      cfr=strcmp(p_stringa,(*p_corrente).stringa);
      if (cfr==0)
         {
          p_temp=(*p_corrente).p_prossimo;
          free((*p_precedente).p_prossimo);
          (*p_precedente).p_prossimo=p_temp;
          p_corrente=p_temp;
          k++;
         }
      else
         {
          continua=0;
         }
     }  // fine ciclo while

  return k;
 }  // fine cancella()
   // dealloca la memoria heap occupata dalla lista
    // elimina anche le due sentinelle
void svuota()
 {
  struct parola *p_temp;
  while(p_radice!=NULL)
    {
     p_temp=(*p_radice).p_prossimo;
     free(p_radice);
     p_radice=p_temp;
    }
 }  // fine svuota

